﻿<?php
include_once $_SERVER['DOCUMENT_ROOT'] .
        '/includes/magicquotes.inc.php';

require_once $_SERVER['DOCUMENT_ROOT'] . '/includes/access.inc.php';

if (!userIsLoggedIn())
{
    include '../login.html.php';
    exit();
}


if (!userHasRole('Administrator autorów'))
{
    $error = 'Strona dostępna tylko dla Administratorów autorów.';
    include '../accessdenied.html.php';
    exit();
}


if (isset($_GET['add']))
{
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/db.inc.php';

    $pagetitle = 'Nowy autor';
    $action = 'addform';
    $name = '';
    $email = '';
    $id = '';
    $button = 'Dodaj autora';

    // Stworzenie listy ról
    $sql = "SELECT id, opis FROM rola";
    $result = mysqli_query($link, $sql);
    if (!$result)
    {
        $error = 'Błąd w trakcie odczytywania listy ról.';
        include 'error.html.php';
        exit();
    }

    while ($row = mysqli_fetch_array($result))
    {
        $roles[] = array(
                'id' => $row['id'],
                'description' => $row['opis'],
                'selected' => FALSE);
    }

    include 'form.html.php';
    exit();
}

if (isset($_GET['addform']))
{
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/db.inc.php';

    $name = mysqli_real_escape_string($link, $_POST['name']);
    $email = mysqli_real_escape_string($link, $_POST['email']);
    $sql = "INSERT INTO autor SET
            nazwisko='$name',
            email='$email'";
    if (!mysqli_query($link, $sql))
    {
        $error = 'Błąd w trakcie dodawania autora.';
        include 'error.html.php';
        exit();
    }

    $authorid = mysqli_insert_id($link);

    if ($_POST['password'] != '')
    {
        $password = md5($_POST['password'] . 'ijdb');
        $password = mysqli_real_escape_string($link, $password);
        $sql = "UPDATE autor SET
                haslo = '$password'
                WHERE id = '$authorid'";
        if (!mysqli_query($link, $sql))
        {
            $error = 'Błąd w trakcie definiowania hasła dla autora.';
            include 'error.html.php';
            exit();
        }
    }

    if (isset($_POST['roles']))
    {
        foreach ($_POST['roles'] as $role)
        {
            $roleid = mysqli_real_escape_string($link, $role);
            $sql = "INSERT INTO rolaautora SET
                    idautora='$authorid',
                    idroli='$roleid'";
            if (!mysqli_query($link, $sql))
            {
                $error = 'Błąd w trakcie przypisywania autorowi wybranych ról.';
                include 'error.html.php';
                exit();
            }
        }
    }

    header('Location: .');
    exit();
}

if (isset($_POST['action']) and $_POST['action'] == 'Edytuj')
{
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/db.inc.php';

    $id = mysqli_real_escape_string($link, $_POST['id']);
    $sql = "SELECT id, nazwisko, email FROM autor WHERE id='$id'";
    $result = mysqli_query($link, $sql);
    if (!$result)
    {
        $error = 'Błąd w trakcie odczytywania danych autora.';
        include 'error.html.php';
        exit();
    }
    $row = mysqli_fetch_array($result);

    $pagetitle = 'Edycja danych autora';
    $action = 'editform';
    $name = $row['nazwisko'];
    $email = $row['email'];
    $id = $row['id'];
    $button = 'Zmień dane autora';

    // Pobranie listy ról przypisanych autorowi
    $sql = "SELECT idroli FROM rolaautora WHERE idautora='$id'";
    $result = mysqli_query($link, $sql);
    if (!$result)
    {
        $error = 'Błąd w trakcie odczytywania listy przypisanych ról.';
        include 'error.html.php';
        exit();
    }

    $selectedRoles = array();
    while ($row = mysqli_fetch_array($result))
    {
        $selectedRoles[] = $row['idroli'];
    }

    // Stworzenie listy wszystkich ról
    $sql = "SELECT id, opis FROM rola";
    $result = mysqli_query($link, $sql);
    if (!$result)
    {
        $error = 'Błąd w trakcie odczytywania listy ról.';
        include 'error.html.php';
        exit();
    }

    while ($row = mysqli_fetch_array($result))
    {
        $roles[] = array(
                'id' => $row['id'],
                'description' => $row['opis'],
                'selected' => in_array($row['id'], $selectedRoles));
    }

    include 'form.html.php';
    exit();
}

if (isset($_GET['editform']))
{
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/db.inc.php';

    $id = mysqli_real_escape_string($link, $_POST['id']);
    $name = mysqli_real_escape_string($link, $_POST['name']);
    $email = mysqli_real_escape_string($link, $_POST['email']);
    $sql = "UPDATE autor SET
            nazwisko='$name',
            email='$email'
            WHERE id='$id'";
    if (!mysqli_query($link, $sql))
    {
        $error = 'Błąd w trakcie zmiany danych autora.';
        include 'error.html.php';
        exit();
    }

    if ($_POST['password'] != '')
    {
        $password = md5($_POST['password'] . 'ijdb');
        $password = mysqli_real_escape_string($link, $password);
        $sql = "UPDATE autor SET
                haslo = '$password'
                WHERE id = '$id'";
        if (!mysqli_query($link, $sql))
        {
            $error = 'Bład w trakcie ustawiania hasła autora.';
            include 'error.html.php';
            exit();
        }
    }

    $sql = "DELETE FROM rolaautora WHERE idautora='$id'";
    if (!mysqli_query($link, $sql))
    {
        $error = 'Błąd w trakcie usuwania ról przypisanych autorowi.';
        include 'error.html.php';
        exit();
    }

    if (isset($_POST['roles']))
    {
        foreach ($_POST['roles'] as $role)
        {
            $roleid = mysqli_real_escape_string($link, $role);
            $sql = "INSERT INTO rolaautora SET
                    idautora='$id',
                    idroli='$roleid'";
            if (!mysqli_query($link, $sql))
            {
                $error = 'Błąd w trakcie przypisywania autorowi wybranych ról.';
                include 'error.html.php';
                exit();
            }
        }
    }

    header('Location: .');
    exit();
}

if (isset($_POST['action']) and $_POST['action'] == 'Usuń')
{
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/db.inc.php';
    $id = mysqli_real_escape_string($link, $_POST['id']);

    // Usunięcie przypisań ról tego autora
    $sql = "DELETE FROM rolaautora WHERE idautora='$id'";
    if (!mysqli_query($link, $sql))
    {
        $error = 'Błąd w trakcie usuwania przypisań ról.';
        include 'error.html.php';
        exit();
    }

    // Odczytanie kawałów autora
    $sql = "SELECT id FROM kawal WHERE idautora='$id'";
    $result = mysqli_query($link, $sql);
    if (!$result)
    {
        $error = 'Błąd w trakcie odczytywania listy kawałów do usunięcia.';
        include 'error.html.php';
        exit();
    }

    // Dla każdego kawału
    while ($row = mysqli_fetch_array($result))
    {
        $jokeId = $row[0];

        // Usunięcie przypisań kategorii do kawału
        $sql = "DELETE FROM kategoriakawalu WHERE idkawalu='$jokeId'";
        if (!mysqli_query($link, $sql))
        {
            $error = 'Błąd w trakcie usuwania przypisań kategorii do kawału.';
            include 'error.html.php';
            exit();
        }
    }

    // Usunięcie kawałów tego autora
    $sql = "DELETE FROM kawal WHERE idautora='$id'";
    if (!mysqli_query($link, $sql))
    {
        $error = 'Błąd w trakcie usuwania kawałów autora.';
        include 'error.html.php';
        exit();
    }

    // Usunięcie autora
    $sql = "DELETE FROM autor WHERE id='$id'";
    if (!mysqli_query($link, $sql))
    {
        $error = 'Błąd w trakcie usuwania autora.';
        include 'error.html.php';
        exit();
    }

    header('Location: .');
    exit();
}

// Wyswietlenie listy autorów
include $_SERVER['DOCUMENT_ROOT'] . '/includes/db.inc.php';
$result = mysqli_query($link, 'SELECT id, nazwisko FROM autor');
if (!$result)
{
    $error = 'Błąd w trakcie odczytywania autorów z bazy danych!';
    include 'error.html.php';
    exit();
}

while ($row = mysqli_fetch_array($result))
{
    $authors[] = array('id' => $row['id'], 'name' => $row['nazwisko']);
}

include 'authors.html.php';
?>
